package tk.antoine_roux.wiki.model.response;

import com.fasterxml.jackson.annotation.JsonProperty;
import tk.antoine_roux.wiki.model.response.secondary.*;

import java.util.List;
import java.util.Map;

/**
 * job format use to submit
 * information to gitlab-runner
 */
public class JobResponse {
    public Integer id;
    public String token;
    @JsonProperty("allow_git_fetch")
    public boolean allowGitFetch;
    @JsonProperty("job_info")
    public JobInfo jobInfo;
    @JsonProperty("git_info")
    public GitInfo gitInfo;
    public RunnerInfo runnerInfo;
    public List<JobVariable> variables;
    public List<Step> steps;
    public Image image;
    public List<Image> services;
    public List<Artifact> artifacts;
    public List<Cache> cache;
    public List<Credential> credentials;
    public List<Dependency> dependencies;
    public GitLabFeatures features;
    public Map<String, Secret> secrets;
}
